/* IBM_PROLOG_BEGIN_TAG                                                   */
/* This is an automatically generated prolog.                             */
/*                                                                        */
/*                                                                        */
/*                                                                        */
/* IBM CONFIDENTIAL                                                       */
/*                                                                        */
/* OBJECT CODE ONLY SOURCE MATERIALS                                      */
/*                                                                        */
/* COPYRIGHT International Business Machines Corp. 2005, 2006         */
/* All Rights Reserved                                                    */
/*                                                                        */
/* The source code for this program is not published or otherwise         */
/* divested of its trade secrets, irrespective of what has been           */
/* deposited with the U.S. Copyright Office.                              */
/*                                                                        */
/* IBM_PROLOG_END_TAG                                                     */

// ABOUT:
// This overload (One of a pair) demonstrates chaining multiple overloads
// together.

// wire.h contains the SVN OpenGL enumerants (e.g. GLCOLOR3F etc.) and must be included
#include "wire.h"

static void(*s_glColor3f)(float,float,float);
static void o_2_glColor3f(float,float,float);

void Overload(glOp *glOperationsTable, glOp *glSystemOperationsTable)
{
    // Acquire a pointer to the 'true' OpenGL function for future use.
    s_glColor3f = (void(*)(float,float,float)) glOperationsTable [GLCOLOR3F];

    // Overload the set of OpenGL functions seen by the application with.
    // our custom glColor3f call instead
    glOperationsTable[GLCOLOR3F] = (glOp)o_2_glColor3f;
}

static void
o_2_glColor3f(float r, float g, float b)
{
    // Change all color calls to be just BLUE
    float modified_r = 0;
    float modified_g = 0;
    float modified_b = 1;

    // Call the 'true' glColor3f OpenGL function with modified values.
    (*s_glColor3f)(modified_r,modified_g,modified_b);
}
