/* IBM_PROLOG_BEGIN_TAG                                                   */
/* This is an automatically generated prolog.                             */
/*                                                                        */
/*                                                                        */
/*                                                                        */
/* Licensed Materials - Property of IBM                                   */
/*                                                                        */
/* COPYRIGHT International Business Machines Corp. 2004,2005          */
/* All Rights Reserved                                                    */
/*                                                                        */
/* US Government Users Restricted Rights - Use, duplication or            */
/* disclosure restricted by GSA ADP Schedule Contract with IBM Corp.      */
/*                                                                        */
/* IBM_PROLOG_END_TAG                                                     */
/* @(#) 1.2 src/dcv/svn/test/rotvp.c, dcv, dcv_rpil, rpils003d 06/07/31 10:51:14 */

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <math.h>
#include <X11/Xlib.h>
#include <GL/gl.h>
#include <GL/glx.h>
#include <time.h>

#define DEPTH	24

static int glattr[] =
{
	GLX_RGBA,
	GLX_DOUBLEBUFFER,
	GLX_RED_SIZE,   1,      /* 2,3 */
	GLX_GREEN_SIZE, 1,      /* 4,5 */
	GLX_BLUE_SIZE,  1,      /* 6,7 */
	0                       /* 10  */
};

main(int argc, char *argv[])
{
    XSetWindowAttributes attr;
    XVisualInfo *vi;
    int i, scrn, mask;
    Display *dpy;
    Window win, root;
    XImage *ximg;
    GLXContext ctx;
    char *renderer;
	int count = 10000;

    dpy = XOpenDisplay(NULL);
    if (! dpy)
    {
	fprintf(stderr, "SVN: unable to open display %s\n",getenv("DISPLAY"));
	exit(1);
    }

    scrn = DefaultScreen(dpy);
    root = DefaultRootWindow(dpy);

    vi = glXChooseVisual(dpy, scrn, glattr);
    if (! vi)
    {
	fprintf(stderr, "SVN: error getting visual\n");
	exit(1);
    }

    attr.colormap = XCreateColormap(dpy, root, vi->visual, AllocNone);
    mask = CWColormap;

    win = XCreateWindow(dpy, root, 0, 0, 500, 500, 0,
                            DEPTH, InputOutput, vi->visual, mask, &attr);
    if (! win)
    {
	fprintf(stderr, "SVN: unable to create window\n");
 	exit(1);	
    }

    XMapWindow(dpy, win);
    XFlush(dpy);


    ctx = glXCreateContext(dpy, vi, NULL, 1);
    if (! ctx) ctx = glXCreateContext(dpy, vi, NULL, 0);
    if (! ctx)
    {
	fprintf(stderr, "SVN: error creating GLX context\n");
	exit(1);
    }

    glXMakeCurrent(dpy, win, ctx);

    glClearColor(0.0, 0.0, 0.0, 0.0);

    glMatrixMode(GL_PROJECTION);
    glLoadIdentity();
    glOrtho(-1.0, 1.0, -1.0, 1.0, -1.0, 1.0);

    glMatrixMode(GL_MODELVIEW);
    glLoadIdentity();

    renderer = (char *)glGetString(GL_RENDERER);
    if (! renderer)
	fprintf(stderr, "SVN: renderer is not set\n");

	if (argc > 1) count = atoi(argv[1]);

    for (i = 0; i < count; i++)
    {
	glClear(GL_COLOR_BUFFER_BIT);
	glViewport(0, 0, 250, 250);
	glRotatef(5.0, 1.0, 0.0, 1.0);
	glBegin(GL_QUADS);
	glColor3f(1.0, 0.0, 0.0);
	glVertex3f(0.75, 0.75, 0.0);
	glVertex3f(0.75, -0.75, 0.0);
	glVertex3f(-0.75, -0.75, 0.0);
	glVertex3f(-0.75, 0.75, 0.0);
	glEnd();
	glViewport(255, 255, 100, 100);
	glRotatef(5.0, 0.0, 0.0, 1.0);
	glBegin(GL_QUADS);
	glColor3f(1.0, 1.0, 0.0);
	glVertex3f(0.75, 0.75, 0.0);
	glVertex3f(0.75, -0.75, 0.0);
	glVertex3f(-0.75, -0.75, 0.0);
	glVertex3f(-0.75, 0.75, 0.0);
	glEnd();
	glXSwapBuffers(dpy, win);
    }

    exit(0);
}
